Index: palm/trunk/SOURCE/diffusion_v.f90
===================================================================
--- palm/trunk/SOURCE/diffusion_v.f90	(revision 4901)
+++ palm/trunk/SOURCE/diffusion_v.f90	(revision 1)
@@ -310,218 +233,137 @@
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for grid point i,j
-!--------------------------------------------------------------------------------------------------!
-    SUBROUTINE diffusion_v_ij( i, j )
-
-       USE arrays_3d,                                                                              &
-           ONLY:  ddzu, ddzw, drho_air, km, tend, u, v, w, rho_air_zw
-
-       USE control_parameters,                                                                     &
-           ONLY:  constant_top_momentumflux, use_surface_fluxes, use_top_fluxes
-
-       USE grid_variables,                                                                         &
-           ONLY:  ddx, ddy, ddy2
-
-       USE indices,                                                                                &
-           ONLY:  nzb, nzt, wall_flags_total_0
-
-       USE kinds
-
-       USE surface_mod,                                                                            &
-           ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h, surf_usm_v
+!------------------------------------------------------------------------------!
+! Call for grid point i,j
+!------------------------------------------------------------------------------!
+    SUBROUTINE diffusion_v_ij( i, j, ddzu, ddzw, km, km_damp_x, tend, u, v, &
+                               vsws, w, z0 )
+
+       USE control_parameters
+       USE grid_variables
+       USE indices
 
        IMPLICIT NONE
 
-
-       INTEGER(iwp) ::  i             !< running index x direction
-       INTEGER(iwp) ::  j             !< running index y direction
-       INTEGER(iwp) ::  k             !< running index z direction
-       INTEGER(iwp) ::  l             !< running index of surface type, south- or north-facing wall
-       INTEGER(iwp) ::  m             !< running index surface elements
-       INTEGER(iwp) ::  surf_e        !< End index of surface elements at (j,i)-gridpoint
-       INTEGER(iwp) ::  surf_s        !< Start index of surface elements at (j,i)-gridpoint
-
-       REAL(wp)     ::  flag          !< flag to mask topography grid points
-       REAL(wp)     ::  kmxm          !< diffusion coefficient on leftward side of the v-gridbox - interpolated onto xu-yv grid
-       REAL(wp)     ::  kmxp          !< diffusion coefficient on rightward side of the v-gridbox - interpolated onto xu-yv grid
-       REAL(wp)     ::  kmzm          !< diffusion coefficient on bottom of the gridbox - interpolated onto xu-zw grid
-       REAL(wp)     ::  kmzp          !< diffusion coefficient on top of the gridbox - interpolated onto xu-zw grid
-       REAL(wp)     ::  mask_bottom   !< flag to mask vertical upward-facing surface
-       REAL(wp)     ::  mask_east     !< flag to mask vertical surface south of the grid point
-       REAL(wp)     ::  mask_west     !< flag to mask vertical surface north of the grid point
-       REAL(wp)     ::  mask_top      !< flag to mask vertical downward-facing surface
+       INTEGER ::  i, j, k
+       REAL    ::  kmxm_x, kmxm_y, kmxp_x, kmxp_y, kmzm, kmzp, vsus
+       REAL    ::  ddzu(1:nzt+1), ddzw(1:nzt), km_damp_x(nxl-1:nxr+1)
+       REAL    ::  z0(nys-1:nyn+1,nxl-1:nxr+1)
+       REAL    ::  tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
+       REAL, DIMENSION(:,:),   POINTER ::  vsws
+       REAL, DIMENSION(:,:,:), POINTER ::  km, u, v, w
 
 !
 !--    Compute horizontal diffusion
-       DO  k = nzb+1, nzt
-!
-!--       Predetermine flag to mask topography and wall-bounded grid points.
-!--       It is sufficient to masked only east- and west-facing surfaces, which need special
-!--       treatment for the v-component.
-          flag      = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i),   2 ) )
-          mask_east = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i+1), 2 ) )
-          mask_west = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i-1), 2 ) )
+       DO  k = nzb_v_outer(j,i)+1, nzt
 !
 !--       Interpolate eddy diffusivities on staggered gridpoints
-          kmxp = 0.25_wp * ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
-          kmxm = 0.25_wp * ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
-
-          tend(k,j,i) = tend(k,j,i) +          (                                                   &
-                          mask_east * kmxp * (                                                     &
-                                 ( v(k,j,i+1) - v(k,j,i)     ) * ddx                               &
-                               + ( u(k,j,i+1) - u(k,j-1,i+1) ) * ddy                               &
-                                             )                                                     &
-                        - mask_west * kmxm * (                                                     &
-                                 ( v(k,j,i) - v(k,j,i-1) ) * ddx                                   &
-                               + ( u(k,j,i) - u(k,j-1,i) ) * ddy                                   &
-                                             )                                                     &
-                                               ) * ddx  * flag                                     &
-                                    + 2.0_wp * (                                                   &
-                                  km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i)   )                        &
-                                - km(k,j-1,i) * ( v(k,j,i)   - v(k,j-1,i) )                        &
-                                               ) * ddy2 * flag
+          kmxp_x = 0.25 * ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
+          kmxm_x = 0.25 * ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
+          kmxp_y = kmxp_x
+          kmxm_y = kmxm_x
+!
+!--       Increase diffusion at the outflow boundary in case of non-cyclic
+!--       lateral boundaries. Damping is only needed for velocity components
+!--       parallel to the outflow boundary in the direction normal to the
+!--       outflow boundary.
+          IF ( bc_lr /= 'cyclic' )  THEN
+             kmxp_x = MAX( kmxp_x, km_damp_x(i) )
+             kmxm_x = MAX( kmxm_x, km_damp_x(i) )
+          ENDIF
+
+          tend(k,j,i) = tend(k,j,i)                                          &
+                      & + ( kmxp_x * ( v(k,j,i+1) - v(k,j,i)     ) * ddx     &
+                      &   + kmxp_y * ( u(k,j,i+1) - u(k,j-1,i+1) ) * ddy     &
+                      &   - kmxm_x * ( v(k,j,i) - v(k,j,i-1) ) * ddx         &
+                      &   - kmxm_y * ( u(k,j,i) - u(k,j-1,i) ) * ddy         &
+                      &   ) * ddx                                            &
+                      & + 2.0 * (                                            &
+                      &           km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i) )    &
+                      &         - km(k,j-1,i) * ( v(k,j,i) - v(k,j-1,i) )    &
+                      &         ) * ddy2
        ENDDO
 
 !
-!--    Add horizontal momentum flux v'u' at east- (l=2) and west-facing (l=3) surfaces. Note, in the
-!--    the flat case, loops won't be entered as start_index > end_index. Furtermore, note, no
-!--    vertical natural surfaces so far.
-!--    Default-type surfaces
-       DO  l = 2, 3
-          surf_s = surf_def_v(l)%start_index(j,i)
-          surf_e = surf_def_v(l)%end_index(j,i)
-          DO  m = surf_s, surf_e
-             k           = surf_def_v(l)%k(m)
-             tend(k,j,i) = tend(k,j,i) + surf_def_v(l)%mom_flux_uv(m) * ddx
-          ENDDO
-       ENDDO
-!
-!--    Natural-type surfaces
-       DO  l = 2, 3
-          surf_s = surf_lsm_v(l)%start_index(j,i)
-          surf_e = surf_lsm_v(l)%end_index(j,i)
-          DO  m = surf_s, surf_e
-             k           = surf_lsm_v(l)%k(m)
-             tend(k,j,i) = tend(k,j,i) + surf_lsm_v(l)%mom_flux_uv(m) * ddx
-          ENDDO
-       ENDDO
-!
-!--    Urban-type surfaces
-       DO  l = 2, 3
-          surf_s = surf_usm_v(l)%start_index(j,i)
-          surf_e = surf_usm_v(l)%end_index(j,i)
-          DO  m = surf_s, surf_e
-             k           = surf_usm_v(l)%k(m)
-             tend(k,j,i) = tend(k,j,i) + surf_usm_v(l)%mom_flux_uv(m) * ddx
-          ENDDO
-       ENDDO
-!
-!--    Compute vertical diffusion. In case of simulating a surface layer, respective grid diffusive
-!--    fluxes are masked (flag 8) within this loop, and added further below, else, simple gradient
-!--    approach is applied. Model top is also mask if top-momentum flux is given.
-       DO  k = nzb+1, nzt
-!
-!--       Determine flags to mask topography below and above. Flag 2 is used to mask topography in
-!--       general, while flag 10 implies also information about use_surface_fluxes. Flag 9 is used
-!--       to control momentum flux at model top.
-          mask_bottom = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k-1,j,i), 8 ) )
-          mask_top    = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k+1,j,i), 8 ) ) *         &
-                        MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k+1,j,i), 9 ) )
-          flag        = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 2 ) )
-!
-!--       Interpolate eddy diffusivities on staggered gridpoints
-          kmzp = 0.25_wp * ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
-          kmzm = 0.25_wp * ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
-
-          tend(k,j,i) = tend(k,j,i)                                                                &
-                        & + ( kmzp * ( ( v(k+1,j,i) - v(k,j,i) ) * ddzu(k+1)                       &
-                        &            + ( w(k,j,i) - w(k,j-1,i) ) * ddy                             &
-                        &            ) * rho_air_zw(k)   * mask_top                                &
-                        &   - kmzm * ( ( v(k,j,i)   - v(k-1,j,i)   ) * ddzu(k)                     &
-                        &            + ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy                         &
-                        &            ) * rho_air_zw(k-1) * mask_bottom                             &
-                        &   ) * ddzw(k) * drho_air(k) * flag
-       ENDDO
-
-!
-!--    Vertical diffusion at the first grid point above the surface, if the momentum flux at the
-!--    bottom is given by the Prandtl law or if it is prescribed by the user.
-!--    Difference quotient of the momentum flux is not formed over half of the grid spacing
-!--    (2.0*ddzw(k)) any more, since the comparison with other (LES) models showed that the values
-!--    of the momentum flux becomes too large in this case.
-       IF ( use_surface_fluxes )  THEN
-!
-!--       Default-type surfaces, upward-facing
-          surf_s = surf_def_h(0)%start_index(j,i)
-          surf_e = surf_def_h(0)%end_index(j,i)
-          DO  m = surf_s, surf_e
-             k   = surf_def_h(0)%k(m)
-
-             tend(k,j,i) = tend(k,j,i) + ( - ( - surf_def_h(0)%vsws(m) ) ) * ddzw(k) * drho_air(k)
-          ENDDO
-!
-!--       Default-type surfaces, dowward-facing
-          surf_s = surf_def_h(1)%start_index(j,i)
-          surf_e = surf_def_h(1)%end_index(j,i)
-          DO  m = surf_s, surf_e
-             k   = surf_def_h(1)%k(m)
-
-             tend(k,j,i) = tend(k,j,i) + ( - surf_def_h(1)%vsws(m) ) * ddzw(k) * drho_air(k)
-          ENDDO
-!
-!--       Natural-type surfaces, upward-facing
-          surf_s = surf_lsm_h(0)%start_index(j,i)
-          surf_e = surf_lsm_h(0)%end_index(j,i)
-          DO  m = surf_s, surf_e
-             k   = surf_lsm_h(0)%k(m)
-
-             tend(k,j,i) = tend(k,j,i) + ( - ( - surf_lsm_h(0)%vsws(m) ) ) * ddzw(k) * drho_air(k)
-
-          ENDDO
-!
-!--       Natural-type surfaces, downward-facing
-          surf_s = surf_lsm_h(1)%start_index(j,i)
-          surf_e = surf_lsm_h(1)%end_index(j,i)
-          DO  m = surf_s, surf_e
-             k   = surf_lsm_h(1)%k(m)
-
-             tend(k,j,i) = tend(k,j,i) + ( - surf_lsm_h(1)%vsws(m) ) * ddzw(k) * drho_air(k)
-
-          ENDDO
-!
-!--       Urban-type surfaces, upward-facing
-          surf_s = surf_usm_h(0)%start_index(j,i)
-          surf_e = surf_usm_h(0)%end_index(j,i)
-          DO  m = surf_s, surf_e
-             k   = surf_usm_h(0)%k(m)
-
-             tend(k,j,i) = tend(k,j,i) + ( - ( - surf_usm_h(0)%vsws(m) ) ) * ddzw(k) * drho_air(k)
-
-          ENDDO
-!
-!--       Urban-type surfaces, downward-facing
-          surf_s = surf_usm_h(1)%start_index(j,i)
-          surf_e = surf_usm_h(1)%end_index(j,i)
-          DO  m = surf_s, surf_e
-             k   = surf_usm_h(1)%k(m)
-
-             tend(k,j,i) = tend(k,j,i) + ( - surf_usm_h(1)%vsws(m) ) * ddzw(k) * drho_air(k)
-
+!--    Wall functions at the left and right walls, respectively
+       IF ( wall_v(j,i) /= 0.0 )  THEN
+          DO  k = nzb_v_inner(j,i)+1, nzb_v_outer(j,i)
+             vsus   = kappa * v(k,j,i) / LOG( 0.5 * dx / z0(j,i))
+             vsus   = -vsus * ABS( vsus )
+             kmxp_x = 0.25 * &
+                      ( km(k,j,i)+km(k,j,i+1)+km(k,j-1,i)+km(k,j-1,i+1) )
+             kmxm_x = 0.25 * &
+                      ( km(k,j,i)+km(k,j,i-1)+km(k,j-1,i)+km(k,j-1,i-1) )
+             kmxp_y = kmxp_x
+             kmxm_y = kmxm_x
+!
+!--          Increase diffusion at the outflow boundary in case of
+!--          non-cyclic lateral boundaries. Damping is only needed for
+!--          velocity components parallel to the outflow boundary in
+!--          the direction normal to the outflow boundary.
+             IF ( bc_lr /= 'cyclic' )  THEN
+                kmxp_x = MAX( kmxp_x, km_damp_x(i) )
+                kmxm_x = MAX( kmxm_x, km_damp_x(i) )
+             ENDIF
+
+             tend(k,j,i) = tend(k,j,i)                                         &
+                                 + 2.0 * (                                     &
+                                       km(k,j,i)   * ( v(k,j+1,i) - v(k,j,i) ) &
+                                     - km(k,j-1,i) * ( v(k,j,i) - v(k,j-1,i) ) &
+                                         ) * ddy2                              &
+                                 + (   fxp(j,i) * (                            &
+                                  kmxp_x * ( v(k,j,i+1) - v(k,j,i)     ) * ddx &
+                                + kmxp_y * ( u(k,j,i+1) - u(k,j-1,i+1) ) * ddy &
+                                                  )                            &
+                                     - fxm(j,i) * (                            &
+                                  kmxm_x * ( v(k,j,i) - v(k,j,i-1) ) * ddx     &
+                                + kmxm_y * ( u(k,j,i) - u(k,j-1,i) ) * ddy     &
+                                                  )                            &
+                                     + wall_v(j,i) * vsus                      &
+                                   ) * ddx
           ENDDO
        ENDIF
-!
-!--    Add momentum flux at model top
-       IF ( use_top_fluxes  .AND.  constant_top_momentumflux )  THEN
-          surf_s = surf_def_h(2)%start_index(j,i)
-          surf_e = surf_def_h(2)%end_index(j,i)
-          DO  m = surf_s, surf_e
-
-             k   = surf_def_h(2)%k(m)
-
-             tend(k,j,i) = tend(k,j,i) + ( - surf_def_h(2)%vsws(m) ) * ddzw(k) * drho_air(k)
-          ENDDO
+
+!
+!--    Compute vertical diffusion. In case of simulating a Prandtl layer,
+!--    index k starts at nzb_v_inner+2.
+       DO  k = nzb_diff_v(j,i), nzt
+!
+!--       Interpolate eddy diffusivities on staggered gridpoints
+          kmzp = 0.25 * ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
+          kmzm = 0.25 * ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
+
+          tend(k,j,i) = tend(k,j,i)                                          &
+                      & + ( kmzp * ( ( v(k+1,j,i) - v(k,j,i) ) * ddzu(k+1)   &
+                      &            + ( w(k,j,i) - w(k,j-1,i) ) * ddy         &
+                      &            )                                         &
+                      &   - kmzm * ( ( v(k,j,i)   - v(k-1,j,i)   ) * ddzu(k) &
+                      &            + ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy     &
+                      &            )                                         &
+                      &   ) * ddzw(k)
+       ENDDO
+
+!
+!--    Vertical diffusion at the first grid point above the surface, if the
+!--    momentum flux at the bottom is given by the Prandtl law or if it is
+!--    prescribed by the user.
+!--    Difference quotient of the momentum flux is not formed over half of
+!--    the grid spacing (2.0*ddzw(k)) any more, since the comparison with 
+!--    other (LES) modell showed that the values of the momentum flux becomes
+!--    too large in this case.
+!--    The term containing w(k-1,..) (see above equation) is removed here
+!--    because the vertical velocity is assumed to be zero at the surface.
+       IF ( use_surface_fluxes )  THEN
+          k = nzb_v_inner(j,i)+1
+!
+!--       Interpolate eddy diffusivities on staggered gridpoints
+          kmzp = 0.25 * ( km(k,j,i)+km(k+1,j,i)+km(k,j-1,i)+km(k+1,j-1,i) )
+          kmzm = 0.25 * ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
+
+          tend(k,j,i) = tend(k,j,i)                                          &
+                      & + ( kmzp * ( w(k,j,i) - w(k,j-1,i)     ) * ddy       &
+                      &   ) * ddzw(k)                                        &
+                      & + ( kmzp * ( v(k+1,j,i) - v(k,j,i) ) * ddzu(k+1)     &
+                      &   + vsws(j,i)                                        &
+                      &   ) * ddzw(k)
        ENDIF
 
